package prog2_aufgabe05;

import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTextArea;

public class Middleware {

  /**
   * Liefert den Dateinamen fuer die i-te Bestellung
   *
   * @param nr
   * @return Dateinamen der Bestellung
   */
  private String getBstFilename(int nr) {
    return "Aufgabe05_" + Basic.int2String(nr, 3) + ".bst";
  }

  /**
   * Liefert den Dateinamen fuer die i-te DataMining
   *
   * @param nr
   * @return Dateinamen der DataMining
   */
  private String getDataMiningFilename(int nr) {
    return "Aufgabe05_" + Basic.int2String(nr, 3) + ".dm";
  }

  /**
   * Liefert den Dateinamen fuer die zusammengefassten Bestellung
   *
   * @param nr
   * @return Merge Dateinamen
   */
  private String getMergeFilename() {
    return "Aufgabe05.merge";
  }

  /**
   *
   * @param editor
   * @param maxItems
   * @param anzThreads
   */
  /**
   * Erzeugt die i.te Datei mittels getBstFilename pro Datei: 
   * Schreibt als erstes die Anzahl der Bestellungen 
   * Benutzt eine Instanz der Klasse Random (Konstruktor Bestellung) 
   * Schreibt danach die einzelnen Bestellungen mittels EINER Methode 
   * Schliesst die Datei
   */
  public void Create1_Files(JTextArea editor, int maxItems, int anzThreads) {
    long t1, t2;
    try {
      t1 = System.currentTimeMillis();
      FileOutputStream fout = null;
      BufferedOutputStream bout = null;
      DataOutputStream dout = null;
      Bestellung best;
      Random generator = new Random();
      for (int i = 0; i < anzThreads; i++) {
        System.out.println("i: " + i);
        fout = new FileOutputStream(getBstFilename(i));
        bout = new BufferedOutputStream(fout);
        dout = new DataOutputStream(bout);
        dout.writeInt(maxItems);
        for (int j = 0; j < maxItems; j++) {
          best = new Bestellung(generator);
          best.write2File(dout);
        }
        dout.close();
      }
      t2 = System.currentTimeMillis();
      Basic.MessageBox("Habe fertig", "Die Dateien wurde erzeugt");
      editor.append("\nCreate1 Buffered Zeit: " + (t2 - t1) + "  ms");
    } catch (IOException e) {
      System.err.println("IOException: " + e);
    }
  }

  /**
   *
   * @param editor
   * @param maxItems
   * @param anzThreads
   */
  /**
   * Erzeugt die Dateien mittels Threads
   * 1. Thread Array erzeugen 
   * 2. CreateThread Instanzen erstellen 
   * 3. starten 
   * 4. zusammenfassen j.in 
   * 5. Meldung ausgeben
   */
  public void CreateN_Files(JTextArea editor, int maxItems, int anzThreads) {
    long t1, t2;
    t1 = System.currentTimeMillis();
    CreateThread[] ct = new CreateThread[anzThreads];
    for (int i = 0; i < ct.length; i++) {
      ct[i] = new CreateThread(i, maxItems, getBstFilename(i));
    }
    for (int i = 0; i < ct.length; i++) {
      ct[i].start();
    }
    try {
      for (int i = 0; i < ct.length; i++) {
        ct[i].join();
      }
    } catch (InterruptedException ex) {
      // Logger.getLogger(Aufgabe05.class.getName()).log(Level.SEVERE,
      // null, ex);
    }
    t2 = System.currentTimeMillis(); // .nanoTime();
    Basic.MessageBox("Habe fertig", "Die Dateien wurde erzeugt");
    editor.append("\nCreateN Thread: Buffered Zeit: " + (t2 - t1) + "  ms");
  }

  /**
   *
   * @param editor
   * @param anzThreads
   * @param searchBez
   */
  /**
   * Das DataMining wird mittels Schleife durchgefuehrt 
   * ArrayList erstellen 
   * pro Durchlauf: 
   *   lesen der i-ten Datei (getBstFilename) 
   *   pro Bestellung wird mittels in.....f der Suchstring gesucht 
   *   wenn vorhanden, in die Liste eintragen 
   * Schliesst die Datei Anzahl erhoehen
   *
   * Schreiben der Daten der Liste in die i.te dm-datei (getDataMiningFilename)
   * Schliesst die Datei Anzahl in den Editor ausgeben (append) Meldung ausgeben
   */
  public void DataMining1(JTextArea editor, int anzThreads, String searchBez) {
    long t1, t2;
    int anz = 0;
    ArrayList<Bestellung> liste = new ArrayList<>();
    try {
      t1 = System.currentTimeMillis();
      FileInputStream fin = null;
      DataInputStream din = null;
      BufferedInputStream bin = null;

      FileOutputStream fout = null;
      DataOutputStream dout = null;
      BufferedOutputStream bout = null;
      Bestellung best;
      for (int i = 0; i < anzThreads; i++) {
        System.out.println("DataMining i:" + i);
        liste.clear();
        fin = new FileInputStream(getBstFilename(i));
        bin = new BufferedInputStream(fin);
        din = new DataInputStream(bin);
        int n = din.readInt();
        for (int j = 0; j < n; j++) {
          best = new Bestellung();
          best.readfromFile(din);
          if (best.getBezeichungen().indexOf(searchBez) >= 0) {
            liste.add(best);
          }
        }
        din.close();
        fout = new FileOutputStream(getDataMiningFilename(i)); // byteweise
        bout = new BufferedOutputStream(fout);
        dout = new DataOutputStream(bout);
        dout.writeInt(liste.size());
        for (Bestellung best2 : liste) {
          best2.write2File(dout);
        }
        dout.close();
        System.out.println(n);
        anz += liste.size();
      } // for i

      t2 = System.currentTimeMillis();
      Basic.MessageBox("Habe fertig",
              "Data Mining: Die Dateien wurde verarbeitet");
      editor.append("\nData Mining1 Zeit: " + (t2 - t1) + "  ms");
      editor.append("\n  Anzahl der Datensätze: " + anz);
    } catch (IOException e) {
      System.err.println("IOException: " + e);
    }

  }

  /**
   *
   * @param editor
   * @param anzThreads
   * @param searchBez
   */
  /**
   * Das DataMining wird mittels Threads durchgefuehrt
   * 1. Thread Array erzeugen
   * 2. DataMiningThread Instanzen erstellen 
   * 3. starten 
   * 4. zusammenfassen j.in
   * 5. Anzahl in den Editor ausgeben (append)
   * 6. Meldung ausgeben
   */
  public void DataMiningN(JTextArea editor, int anzThreads, String searchBez) {
    long t1, t2;
    int anz;
    t1 = System.currentTimeMillis();
    DataMiningThread[] st = new DataMiningThread[anzThreads];
    for (int i = 0; i < st.length; i++) {
      st[i] = new DataMiningThread(i, searchBez, getBstFilename(i),
              getDataMiningFilename(i));
    }
    for (int i = 0; i < st.length; i++) {
      st[i].start();
    }
    try {
      for (int i = 0; i < st.length; i++) {
        st[i].join();
      }
    } catch (InterruptedException ex) {
      // Logger.getLogger(Aufgabe05.class.getName()).log(Level.SEVERE,
      // null, ex);
    }
    t2 = System.currentTimeMillis(); // .nanoTime();
    anz = 0;
    for (int i = 0; i < st.length; i++) {
      anz += st[i].getAnz();
    }
    Basic.MessageBox("Habe fertig",
            "Data Mining: Die Dateien wurde verarbeitet");
    editor.append("\nThread Data Mining Buffered Zeit: " + (t2 - t1)
            + "  ms");
    editor.append("\n  Anzahl der Datensätze: " + anz);
  }

  /**
   *
   * @param editor
   * @param anzThreads
   */
  /**
   * Das Merge wird mittels Schleife durchgefuehrt 
   * ArrayList erstellen pro
   * Durchlauf: lesen der i-ten Datei (getDataMiningFilename) 
   * Schliesst die Datei
   *
   * Sortieren Schreiben der Daten der Liste in die Merge-Datei (getMergeFilename) 
   * Schliesst die Datei 
   * Anzahl in den Editor ausgeben (append) 
   * Meldung ausgeben
   */
  public void Merge_Files(JTextArea editor, int anzThreads) {
    long t1, t2;
    ArrayList<Bestellung> liste = new ArrayList<>();
    try {
      t1 = System.currentTimeMillis();
      FileInputStream fin = null;
      DataInputStream din = null;
      BufferedInputStream bin = null;

      FileOutputStream fout = null;
      DataOutputStream dout = null;
      BufferedOutputStream bout = null;
      Bestellung best;
      liste.clear();
      for (int i = 0; i < anzThreads; i++) {
        fin = new FileInputStream(getDataMiningFilename(i));
        bin = new BufferedInputStream(fin);
        din = new DataInputStream(bin);
        int n = din.readInt();
        for (int j = 0; j < n; j++) {
          best = new Bestellung();
          best.readfromFile(din);
          liste.add(best);
        }
        din.close();
        System.out.println("i: " + i + "   anz:" + n);
      } // for i

      Collections.sort(liste);
      fout = new FileOutputStream(getMergeFilename()); // byteweise
      bout = new BufferedOutputStream(fout);
      dout = new DataOutputStream(bout);
      for (Bestellung best2 : liste) {
        best2.write2File(dout);
      }
      dout.close();
      t2 = System.currentTimeMillis();

      Basic.MessageBox("Habe fertig",
              "Merge: Die Dateien wurden zusammengefasst");
      editor.append("\nMerge Zeit: " + (t2 - t1) + "  ms");
      editor.append("\n  Anzahl der Datensätze: " + liste.size());
    } catch (IOException e) {
      System.err.println("IOException: " + e);
    }

  }
}
